Index: sansview/perspectives/fitting/fitpage.py
===================================================================
--- sansview/perspectives/fitting/fitpage.py	(revision 9466f2d6a8ec770363ff314de3d4768470b1a6f6)
+++ sansview/perspectives/fitting/fitpage.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -2667,5 +2651,5 @@
                     
                     ix += 1
-                    ctl3 = self.ModelTextCtrl(self, -1, size=(_BOX_WIDTH/2,20), 
+                    ctl3 = self.ModelTextCtrl(self, -1, size=(_BOX_WIDTH/1.8,20), 
                                               style=wx.TE_PROCESS_ENTER,
                                 text_enter_callback = self._onparamRangeEnter)
@@ -2676,5 +2660,5 @@
                  
                     ix += 1
-                    ctl4 = self.ModelTextCtrl(self, -1, size=(_BOX_WIDTH/2,20),
+                    ctl4 = self.ModelTextCtrl(self, -1, size=(_BOX_WIDTH/1.8,20),
                                                style=wx.TE_PROCESS_ENTER,
                             text_enter_callback = self._onparamRangeEnter)
@@ -2684,6 +2668,5 @@
                     ctl4.Hide()
                     
-                    if self.engine_type =="park" and \
-                            self.data.__class__.__name__ =="Data2D":                      
+                    if self.data.__class__.__name__ =="Data2D":                      
                         ctl3.Show(True)
                         ctl4.Show(True)
@@ -2727,5 +2710,37 @@
         self.Layout()
         self.Refresh()
-     
+        
+    def on_right_down(self, event):
+        """
+        Get key stroke event
+        """
+        if self.data == None:
+            return
+        # Figuring out key combo: Cmd for copy, Alt for paste
+        if event.AltDown() and event.ShiftDown():
+            self._show_ftol_dialog()
+            flag = True
+        else:
+            flag = False
+        # make event free
+        event.Skip()
+        # messages depending on the flag
+        if not flag:
+            msg = " Could not open ftol dialog;"
+            msg += " Check if the Scipy fit engine is selected in the menubar."
+            infor = 'warning'
+            # inform msg to wx
+            wx.PostEvent( self.parent.parent, 
+                          StatusEvent(status= msg, info=infor))
+
+
+    def _show_ftol_dialog(self):
+        """
+        Dialog to select ftol for Scipy
+        """
+        from ftol_dialog import ChangeFtol
+        panel = ChangeFtol(self)
+        panel.ShowModal()
+        
     def _onModel2D(self, event):
         """
Index: sansview/perspectives/fitting/fitpanel.py
===================================================================
--- sansview/perspectives/fitting/fitpanel.py	(revision 9466f2d6a8ec770363ff314de3d4768470b1a6f6)
+++ sansview/perspectives/fitting/fitpanel.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -61,4 +61,5 @@
         #add default pages
         self.add_default_pages()
+
     
     def _on_engine_change(self, name='scipy'):
@@ -140,9 +141,10 @@
         Add default pages such as a hint page and an empty fit page
         """
+        pass
         #add default page
-        from hint_fitpage import HintFitPage
-        self.hint_page = HintFitPage(self) 
-        self.AddPage(self.hint_page,"Hint")
-        self.hint_page.set_manager(self._manager)
+        #from hint_fitpage import HintFitPage
+        #self.hint_page = HintFitPage(self) 
+        #self.AddPage(self.hint_page,"Hint")
+        #self.hint_page.set_manager(self._manager)
   
     def close_all(self):
Index: sansview/perspectives/fitting/fitting.py
===================================================================
--- sansview/perspectives/fitting/fitting.py	(revision 9466f2d6a8ec770363ff314de3d4768470b1a6f6)
+++ sansview/perspectives/fitting/fitting.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -69,4 +69,5 @@
         self.calc_1D = None
         self.fit_thread_list = {}
+        self.residuals = None
         self.fit_panel = None
         # Start with a good default
@@ -74,4 +75,5 @@
         # the type of optimizer selected, park or scipy
         self.fitter  = None
+        self.fit_panel = None
         #let fit ready
         self.fitproblem_count = None
@@ -82,4 +84,6 @@
         ## Fit engine
         self._fit_engine = 'scipy'
+        ## Relative error desired in the sum of squares (float); scipy only
+        self.ftol=1.49012e-08
         #List of selected data
         self.selected_data_list = []
@@ -132,5 +136,5 @@
         id1 = wx.NewId()
         simul_help = "Simultaneous Fit"
-        self.menu1.Append(id1, '&Simultaneous Page',simul_help)
+        self.menu1.Append(id1, '&Simultaneous Fit',simul_help)
         wx.EVT_MENU(owner, id1, self.on_add_sim_page)
         
@@ -143,5 +147,5 @@
    
         #create  menubar items
-        return [(self.menu1, "Fitting")]
+        return [(self.menu1, "FitEngine")]
                
     def on_add_sim_page(self, event):
@@ -445,5 +449,18 @@
                 param_name=param_names[1]                    
             return model_name,param_name
-        
+   
+    def set_ftol(self, ftol=None):
+        """
+        Set ftol: Relative error desired in the sum of chi squares.  
+        """
+        # check if it is flaot
+        try:
+            f_tol = float(ftol)
+        except:
+            # default
+            f_tol = 1.49012e-08
+            
+        self.ftol = f_tol
+              
     def stop_fit(self, uid):
         """
@@ -492,5 +509,7 @@
                    state=None,
                    toggle_mode_on=False,
-                   qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX, qstep=DEFAULT_NPTS):
+                   qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX, 
+                   qstep=DEFAULT_NPTS,
+                   update_chisqr=True):
         """
         Draw model.
@@ -505,4 +524,5 @@
         :param qmax:  Range's maximum value to draw model
         :param qstep: number of step to divide the x and y-axis
+        :param update_chisqr: update chisqr [bool]
              
         """
@@ -519,5 +539,6 @@
                                toggle_mode_on=toggle_mode_on,
                                state=state,
-                               qstep=qstep)
+                               qstep=qstep,
+                               update_chisqr=update_chisqr)
         else:     
             ## draw model 2D with no initial data
@@ -531,5 +552,6 @@
                                 state=state,
                                 toggle_mode_on=toggle_mode_on,
-                                qstep=qstep)
+                                qstep=qstep,
+                                update_chisqr=update_chisqr)
             
     def onFit(self):
@@ -598,7 +620,8 @@
             calc_fit = FitThread(handler = handler,
                                     fn=fitter,
-                                   pars=pars,
-                                   page_id=list_page_id,
-                                   completefn=self._single_fit_completed)
+                                    pars=pars,
+                                    page_id=list_page_id,
+                                    completefn=self._single_fit_completed,
+                                    ftol=self.ftol)
         else:
             current_page_id = self.sim_page.uid
@@ -607,5 +630,6 @@
                                     fn=fitter,
                                     page_id=list_page_id,
-                                   completefn= self._simul_fit_completed)
+                                    updatefn=handler.update_fit,
+                                    ftol=self.ftol)
         self.fit_thread_list[current_page_id] = calc_fit
         calc_fit.queue()
@@ -851,7 +875,9 @@
         try:
             if result == None:
-                msg= "Simple Fitting Stop !!!"
-                wx.PostEvent(self.parent, StatusEvent(status=msg,info="warning",
-                                                      type="stop"))
+                msg= "Single Fitting did not converge!!!"
+                wx.PostEvent(self.parent, 
+                             StatusEvent(status=msg, 
+                                         info="warning",
+                                         type="stop"))
                 return
             if not numpy.isfinite(result.fitness) or \
@@ -860,5 +886,7 @@
                 msg = "Single Fitting did not converge!!!"
                 wx.PostEvent(self.parent, 
-                             StatusEvent(status=msg, type="stop"))
+                             StatusEvent(status=msg, 
+                                         info="warning",
+                                         type="stop"))
                 return
             for uid in page_id:
@@ -875,5 +903,10 @@
                                   param_name, result.pvec,result.stderr)
                 cpage._on_fit_complete()
-           
+
+        except ValueError:
+            msg = "Single Fitting did not converge!!!"
+            wx.PostEvent(self.parent, StatusEvent(status=msg, info="error",
+                                                  type="stop"))
+            return   
         except:
             raise
@@ -899,5 +932,5 @@
             msg = "" 
             if result == None:
-                msg = "Complex Fitting Stop !!!"
+                msg= "Complex Fitting did not converge!!!"
                 wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                       type="stop"))
@@ -933,4 +966,11 @@
                                   small_out,small_cov)
                 cpage._on_fit_complete()
+                
+        except Exception:
+            msg = "Complex Fitting did not converge!!!"
+            wx.PostEvent(self.parent, StatusEvent(status=msg, info="error",
+                                                  type="stop"))
+            return
+
         except:
             msg = "Simultaneous Fit completed"
@@ -1144,5 +1184,6 @@
   
     def _complete1D(self, x,y, page_id, elapsed,index,model,
-                    toggle_mode_on=False,state=None, data=None):
+                    toggle_mode_on=False,state=None, 
+                    data=None, update_chisqr=True):
         """
         Complete plotting 1D data
@@ -1202,11 +1243,15 @@
             wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot,
                                             title= str(title)))
-            
-            wx.PostEvent(current_pg,
-                Chi2UpdateEvent(output=self._cal_chisqr(data=data,
+            if update_chisqr:
+                wx.PostEvent(current_pg,
+                             Chi2UpdateEvent(output=self._cal_chisqr(data=data,
                                                         page_id=page_id,
                                                         index=index)))
+            else:
+                self._plot_residuals(page_id, data, index)
+
             msg = "Plot 1D  complete !"
             wx.PostEvent( self.parent, StatusEvent(status=msg, type="stop" ))
+            #self.current_pg.state.theory_data = deepcopy(self.theory_data)
         except:
             raise
@@ -1224,5 +1269,6 @@
   
     def _complete2D(self, image, data, model, page_id,  elapsed, index, qmin,
-                     qmax, toggle_mode_on=False,state=None,qstep=DEFAULT_NPTS):
+                     qmax, toggle_mode_on=False,state=None,qstep=DEFAULT_NPTS, 
+                     update_chisqr=True):
         """
         Complete get the result of modelthread and create model 2D
@@ -1284,8 +1330,12 @@
                                                title=title))
         # Chisqr in fitpage
-        wx.PostEvent(current_pg,
-            Chi2UpdateEvent(output=self._cal_chisqr(data=data,
+        if update_chisqr:
+            wx.PostEvent(current_pg,
+                         Chi2UpdateEvent(output=\
+                                    self._cal_chisqr(data=data,
                                                      page_id=page_id,
                                                      index=index)))
+        else:
+            self._plot_residuals(page_id, data, index)
         msg = "Plot 2D complete !"
         wx.PostEvent(self.parent, StatusEvent(status=msg, type="stop"))
@@ -1296,5 +1346,6 @@
                       toggle_mode_on=False,
                       qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX,
-                       qstep=DEFAULT_NPTS):
+                      qstep=DEFAULT_NPTS,
+                      update_chisqr=True):
         """
         draw model in 2D
@@ -1346,6 +1397,8 @@
                                     toggle_mode_on=toggle_mode_on,
                                     state=state,
-                                    completefn=self._complete2D)#,
-                                    #updatefn=self._update2D)
+                                    completefn=self._complete2D,
+                                    #updatefn= self._update2D,
+                                    update_chisqr=update_chisqr)
+
             self.calc_2D.queue()
 
@@ -1360,5 +1413,6 @@
                 state=None,
                 toggle_mode_on=False,
-                qstep=DEFAULT_NPTS, enable1D=True):
+                qstep=DEFAULT_NPTS, update_chisqr=True, 
+                enable1D=True):
         """
         Draw model 1D from loaded data1D
@@ -1378,8 +1432,9 @@
                 return
             x = data.x
-            if qmin == DEFAULT_QMIN :
-                qmin = min(data.x)
-            if qmax == DEFAULT_QMAX:
-                qmax = max(data.x) 
+            if qmin == None :
+                qmin == DEFAULT_QMIN
+
+            if qmax == None:
+                qmax == DEFAULT_QMAX 
         if not enable1D:
             return 
@@ -1398,6 +1453,8 @@
                                   state=state,
                                   toggle_mode_on=toggle_mode_on,
-                                  completefn=self._complete1D)#,
-                                  #updatefn=self._update1D)
+                                  completefn=self._complete1D,
+                                  #updatefn = self._update1D,
+                                  update_chisqr=update_chisqr)
+
             self.calc_1D.queue()
 
@@ -1419,9 +1476,10 @@
         
         # Get data: data I, theory I, and data dI in order
-        if data.__class__.__name__ =="Data2D":
+        if data.__class__.__name__ == "Data2D":
             if index == None: 
                 index = numpy.ones(len(data.data),ntype=bool)
             # get rid of zero error points
-            index = index & (data.err_data != 0)  
+            index = index & (data.err_data != 0 )  
+            index = index & (numpy.isfinite(data.data)) 
             fn = data.data[index] 
             theory_data = self.page_finder[page_id].get_theory_data()
@@ -1430,5 +1488,5 @@
         else:
             # 1 d theory from model_thread is only in the range of index
-            if index == None:
+            if index == None: 
                 index = numpy.ones(len(data.y), ntype=bool)
             if data.dy == None or data.dy == []:
@@ -1437,5 +1495,5 @@
                 ## Set consitently w/AbstractFitengine:
                 # But this should be corrected later.
-                dy = data.dy
+                dy = deepcopy(data.dy)
                 dy[dy==0] = 1  
             fn = data.y[index] 
@@ -1444,11 +1502,99 @@
             en = dy[index]
         # residual
-        res = (fn - gn)/en
+        res = (fn - gn) / en
+        residuals = res[numpy.isfinite(res)]
         # get chisqr only w/finite
-        val = res[numpy.isfinite(res)]*res[numpy.isfinite(res)]
-        chisqr = numpy.average(val)
+        chisqr = numpy.average(residuals * residuals)
+        
+        self._plot_residuals(page_id, data, index)
         return chisqr
     
-    
+
+        
+    def _plot_residuals(self, page_id, data=None, index=None): 
+        """
+        Plot the residuals
+        
+        :param data: data
+        :param index: index array (bool) 
+        : Note: this is different from the residuals in cal_chisqr()
+        """
+        if data == None: 
+            return 
+        
+        # Get data: data I, theory I, and data dI in order
+        if data.__class__.__name__ == "Data2D":
+            # build residuals
+            #print data
+            residuals = Data2D()
+            #residuals.copy_from_datainfo(data)
+            # Not for trunk the line below, instead use the line above
+            data.clone_without_data(len(data.data), residuals)
+            residuals.data = None
+            fn = data.data#[index] 
+            theory_data = self.page_finder[page_id].get_theory_data()
+            gn = theory_data.data#[index]
+            en = data.err_data#[index]
+            residuals.data = (fn - gn) / en 
+            residuals.qx_data = data.qx_data#[index]
+            residuals.qy_data = data.qy_data #[index]
+            residuals.q_data = data.q_data#[index]
+            residuals.err_data = numpy.ones(len(residuals.data))#[index]
+            residuals.xmin = min(residuals.qx_data)
+            residuals.xmax = max(residuals.qx_data)
+            residuals.ymin = min(residuals.qy_data)
+            residuals.ymax = max(residuals.qy_data)
+            residuals.q_data = data.q_data#[index]
+            residuals.mask = data.mask
+            residuals.scale = 'linear'
+            #print "print data",residuals
+            # check the lengths
+            if len(residuals.data) != len(residuals.q_data):
+                return
+
+        else:
+            # 1 d theory from model_thread is only in the range of index
+            if data.dy == None or data.dy == []:
+                dy = numpy.ones(len(data.y))
+            else:
+                ## Set consitently w/AbstractFitengine: 
+                ## But this should be corrected later.
+                dy = deepcopy(data.dy)
+                dy[dy==0] = 1  
+            fn = data.y[index] 
+            theory_data = self.page_finder[page_id].get_theory_data()
+            gn = theory_data.y
+            en = dy[index]
+            # build residuals
+            residuals = Data1D()
+            residuals.y = (fn - gn) / en
+            residuals.x = data.x[index]
+            residuals.dy = numpy.ones(len(residuals.y))
+            residuals.dx = None
+            residuals.dxl = None
+            residuals.dxw = None
+            residuals.ytransform = 'y'
+            # For latter scale changes 
+            residuals.xaxis('\\rm{Q} ', 'A^{-1}')
+            residuals.yaxis('\\rm{Residuals} ', 'normalized')
+            
+        new_plot = residuals
+        if data.id == None:
+            data.id = data.name
+        name  = data.id
+        new_plot.name = "Residuals for " + str(data.name)
+        ## allow to highlight data when plotted
+        new_plot.interactive = True
+        ## when 2 data have the same id override the 1 st plotted
+        new_plot.id = new_plot.name#name + " residuals"
+        ##group_id specify on which panel to plot this data
+        new_plot.group_id = new_plot.id
+        #new_plot.is_data = True
+        ##post data to plot
+        title = new_plot.name 
+        
+        # plot data
+        wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot, title=title))   
+   
 #def profile(fn, *args, **kw):
 #    import cProfile, pstats, os
Index: sansview/perspectives/fitting/ftol_dialog.py
===================================================================
--- sansview/perspectives/fitting/ftol_dialog.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
+++ sansview/perspectives/fitting/ftol_dialog.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -0,0 +1,122 @@
+
+################################################################################
+#This software was developed by the University of Tennessee as part of the
+#Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+#project funded by the US National Science Foundation. 
+#
+#See the license text in license.txt
+#
+#copyright 2009, University of Tennessee
+################################################################################
+import wx
+import sys
+from sans.guicomm.events import StatusEvent  
+# default ftol
+F_TOL = 1.49012e-08 
+
+if sys.platform.count("win32") > 0:
+    PANEL_WIDTH = 270 
+    PANEL_HEIGHT = 250
+    FONT_VARIANT = 0
+else:
+    PANEL_WIDTH = 285
+    PANEL_HEIGHT = 255
+    FONT_VARIANT = 1
+    
+"""
+Dialog to set ftol for Scipy
+
+    ftol(float): Relative error desired in the sum of squares.
+"""
+class ChangeFtol(wx.Dialog):
+    """
+    Dialog to select ftol
+    """
+    def __init__(self, parent, id=-1, title="FTolerance"):
+        wx.Dialog.__init__(self, parent, id, title, 
+                           size=(PANEL_WIDTH, PANEL_HEIGHT))
+        # parent
+        self.parent = parent
+        # default ftol
+        self.ftol = F_TOL
+                # font size 
+        self.SetWindowVariant(variant=FONT_VARIANT)
+        # build layout
+        panel = wx.Panel(self, -1)
+        vbox = wx.BoxSizer(wx.VERTICAL)
+        wx.StaticBox(panel, -1, 'ftol selection (Scipy)', (5, 5),
+                      (PANEL_WIDTH*0.9, PANEL_HEIGHT*0.65))
+        default_bt = wx.RadioButton(panel, -1, 'Default', (15, 30), 
+                                    style=wx.RB_GROUP)
+        default_bt.Bind(wx.EVT_RADIOBUTTON, self.OnFtolSelection)
+        default_bt.SetValue(True)
+        high_bt = wx.RadioButton(panel, -1, '1e-06', (15, 55))
+        high_bt.SetValue(False)
+        high_bt.Bind(wx.EVT_RADIOBUTTON, self.OnFtolSelection)
+        mid_bt = wx.RadioButton(panel, -1, '1e-05', (15, 80))
+        mid_bt.SetValue(False)
+        mid_bt.Bind(wx.EVT_RADIOBUTTON, self.OnFtolSelection)
+        low_bt = wx.RadioButton(panel, -1, '1e-04', (15, 105))
+        low_bt.SetValue(False)
+        low_bt.Bind(wx.EVT_RADIOBUTTON, self.OnFtolSelection)
+        self.custom_bt = wx.RadioButton(panel, -1, 'Custom', (15, 130))
+        self.custom_bt.SetValue(False)
+        self.custom_bt.Bind(wx.EVT_RADIOBUTTON, self.OnFtolSelection)
+        self.custombox = wx.TextCtrl(panel, -1, '', (95, 130))
+        self.custombox.Disable()
+        hbox = wx.BoxSizer(wx.HORIZONTAL)
+        okButton = wx.Button(self, -1, 'Set', size=(70, 30))
+        hbox.Add(okButton, 1, wx.RIGHT, 5)
+        okButton.Bind(wx.EVT_BUTTON, self.OnClose)
+        vbox.Add(panel)
+        vbox.Add(hbox, 1, wx.ALIGN_CENTER | wx.TOP | wx.BOTTOM, 10)
+        # set sizer
+        self.SetSizer(vbox)
+ 
+    def OnFtolSelection(self, event=None):
+        """
+        Changes the ftol on selection of the radio button
+        """
+        event.Skip()
+        # event object and selection
+        button = event.GetEventObject()
+        selection = button.GetLabel()
+        # get float value 
+        if selection == 'Default':
+            ftol = F_TOL   
+            self.custombox.Disable()     
+        elif selection == 'Custom':
+            ftol = F_TOL 
+            self.custombox.Enable(True)
+        else:
+            ftol =  float(selection)
+            self.custombox.Disable()
+        self.ftol = ftol    
+        
+
+    def OnClose(self, event):
+        """
+        Close event
+        """
+        # clear event
+        event.Skip()
+        flag = True
+        # I case of the custom ftol
+        if self.custom_bt.GetValue():
+            try:
+                ftol = float(self.custombox.GetValue())
+                self.ftol = ftol
+            except:
+                flag = False
+        if flag:
+            # set ftol in fitting
+            self.parent.manager.set_ftol(self.ftol) 
+            msg = "The ftol (Scipy) is set to %s." % self.ftol
+        else:
+           msg = "Error in the selection... No changes in ftol."
+        # post event for info
+        wx.PostEvent( self.parent.manager.parent, 
+                      StatusEvent(status= msg, info='warning')) 
+    
+        self.Destroy()
+
Index: sansview/perspectives/fitting/model_thread.py
===================================================================
--- sansview/perspectives/fitting/model_thread.py	(revision e4957fb9ebb34757ae5ada73fadbe9135c02ee27)
+++ sansview/perspectives/fitting/model_thread.py	(revision 22963162e77a658f5b9affbe8d77c9cda810b0a3)
@@ -20,4 +20,5 @@
                  completefn = None,
                  updatefn   = None,
+                 update_chisqr=True,
                  yieldtime  = 0.01,
                  worktime   = 0.01
@@ -40,4 +41,5 @@
         self.smearer = smearer#(data=self.data,model=self.model)
         self.starttime = 0  
+        self.update_chisqr = update_chisqr
         
     def compute(self):
@@ -130,5 +132,6 @@
                        qmin=self.qmin,
                        qmax=self.qmax,
-                       qstep=self.qstep)
+                       qstep=self.qstep,
+                       update_chisqr = self.update_chisqr )
         
 
@@ -146,4 +149,5 @@
                  state=None,
                  completefn = None,
+                 update_chisqr=True,
                  updatefn   = None,
                  yieldtime  = 0.01,
@@ -166,4 +170,5 @@
         self.smearer = smearer
         self.starttime = 0
+        self.update_chisqr = update_chisqr
         
     def compute(self):
@@ -190,5 +195,6 @@
                       toggle_mode_on=self.toggle_mode_on,
                       elapsed=elapsed,index=index, model=self.model,
-                                        data=self.data)
+                      data=self.data, 
+                      update_chisqr = self.update_chisqr )
         
     def results(self):
